#include "table_comptes.h"


// creation de la base de donnees
void etape1(table_comptes *table, int nb_entrees);

// service consultation
void etape2_consultation(table_comptes *table);
void etape2_consultation2(table_comptes *table,int socket2);
int control1(char *idcompte, char *nom, char *prenom, char *mdp, char *solde, table_comptes *table);

// service virement
void etape2_transfert(table_comptes *table);
void etape2_transfert2(table_comptes *table,int socket2);
int control2(char *idcompte, char *nom, char *prenom, char *mdp, char *solde, table_comptes *table);
int virement(char *idcompteA, char *nomA, char *prenomA, char *mdpA, char *soldeA, char *idcompteB, char *nomB, char *prenomB, char *mdpB, char *soldeB, char *somme, table_comptes *table);

// service periodique
void etape3(table_comptes *table);


struct table_et_socket 
{
       table_comptes *table;       // adresse table
       int    socket;   // adresse socket
};


DWORD WINAPI Thread_service_consultation(LPVOID lpParameter)
{
/* Partie 2 - Activation du service de consultation */
   table_comptes *table;
   table= (table_comptes *)lpParameter;
   etape2_consultation(table);
/* Fin de la partie 2 de consultation */
}

DWORD WINAPI Thread_service_consultation2(LPVOID basedonnees_et_socketclient)
{
/* Partie 2 - Traitement en thread d'une connexion client */
   table_et_socket* infos;
   infos = (table_et_socket*) basedonnees_et_socketclient;
   table_comptes *table;
   table= infos->table;
   int socket2;
   socket2 = infos->socket;
   etape2_consultation2(table,socket2);
/* Fin de la partie 2 de consultation avec connexion client */
}

DWORD WINAPI Thread_service_virement(LPVOID lpParameter)
{
/* Partie 2 - transfert argent */
   table_comptes *table;
   table= (table_comptes *)lpParameter;
   etape2_transfert(table);
/* Fin de la partie 2 de virement */
}

DWORD WINAPI Thread_service_virement2(LPVOID basedonnees_et_socketclient)
{
/* Partie 2 - Traitement en thread d'une connexion client */
   table_et_socket* infos;
   infos = (table_et_socket*) basedonnees_et_socketclient;
   table_comptes *table;
   table= infos->table;
   int socket2;
   socket2 = infos->socket;
   etape2_transfert2(table,socket2);
/* Fin de la partie 2 de virement avec connexion client */
}


int main(int argc, char* argv[])
{
    // pointeur vers les threads
    DWORD threadID; 


/* Partie 1 - On charge en memoire la table des comptes */
    printf("Demarrage du sereur bancaire\n\n");
    printf("On commence par charger en memoire la table des comptes\n");
    table_comptes *table = NULL;
    int nb_entrees=0;
    FILE *f = NULL;
    f = fopen ( "la_table_des_comptes" , "r" );
    if (f == NULL) 
    {
        printf("Erreur de lecture de la base de donnees\n");
        exit(-1);
    }
    fscanf(f, "%d", &nb_entrees); 
    table = new table_comptes[nb_entrees];
    table->setnb_entrees(nb_entrees);
    fclose(f);
    etape1(table, nb_entrees);
printf("Fin du chargement en memoire la table des comptes\n\n");
/* Fin de la partie 1 */


printf("Creation du thread service consultation\n");
CreateThread(NULL, 0, Thread_service_consultation, table, 0, &threadID);

printf("Creation du thread service virement\n");
CreateThread(NULL, 0, Thread_service_virement, table, 0, &threadID);


/* Partie 3 - analyse periodique */
   printf("Demarrage du service periodique\n");
   etape3(table);
/* Fin de la partie 3 analyse periodique */


    system("PAUSE"); 
    delete table; // suppression des donnees en memoire
    return 0; // EXIT_SUCCESS
}


#include "service_creation_base_de_donnees.cpp"
#include "service_consultation.cpp"
#include "service_transfert.cpp"
#include "service_periodique.cpp"

