#include "table_comptes.h"

///////////////////////////////////////////
// Creation de l'objet
table_comptes::table_comptes(void)
{
    // creation du mutex pour protger le solde
    mutex_solde = CreateMutex(NULL, FALSE, NULL); // mutex anonyme
	// Erreur de cration ?
	if (!mutex_solde)
		printf("Impossible de crer le mutex\n");
}


void table_comptes::setid(string id_)
{
    id = id_;
}


void table_comptes::setnom(string nom_)
{
     nom=nom_;
}

void table_comptes::setprenom(string prenom_)
{
     prenom=prenom_;
}

void table_comptes::setmdp(string mdp_)
{
     mdp=mdp_;
}

void table_comptes::setsolde(double solde_)
{
     solde = solde_;
}

string table_comptes::getid(void)
{
     return id;
}

string table_comptes::getnom(void)
{
     return nom;
}

string table_comptes::getprenom(void)
{
     return prenom;
}

string table_comptes::getmdp(void)
{
     return mdp;
}

double table_comptes::getsolde(void)
{
     return solde;
}

double table_comptes::changesolde(double valeur)
{
     // il s'agit d'une opration critique, aussi, on protege a l'aide d'un mutex
     WaitForSingleObject( mutex_solde, INFINITE ); // acqurir le mutex
     solde = solde + valeur;
     ReleaseMutex( mutex_solde ); // librer le mutex
     // fin de l'operation critique
     return solde;
}

double table_comptes::changesolde_controle(double valeur)
{
     // il s'agit d'une opration critique, aussi, on protege a l'aide d'un mutex
     WaitForSingleObject( mutex_solde, INFINITE ); // acqurir le mutex
     if( (solde+valeur) < 0) // on verifie que le solde sera bien positif
     {
          ReleaseMutex( mutex_solde ); // librer le mutex
          return -1;
     }

     // si a la fin de l'operation, le solde est positif, alors on procede a l'operation
     solde = solde + valeur;
     ReleaseMutex( mutex_solde ); // librer le mutex
     // fin de l'operation critique
     return solde;
}

void table_comptes::setnb_entrees(int nb_)
{
    nb_entrees=nb_;
}


int table_comptes::getnb_entrees(void)
{
    return nb_entrees;
}

void table_comptes::display(void)
{
    printf("id=%s - nom=%s - prenom=%s - mdp=%s - solde=%f\n",id.c_str(),nom.c_str(),prenom.c_str(),mdp.c_str(),solde);
    return;
}
